C++LeetCode 구현(63.서로 다른 경로 의 2)

[LeetCode]63.Unique Paths II 다른 경로 의 2
A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).
The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).
Now consider if some obstacles are added to the grids. How many unique paths would there be?

An obstacle and empty space is marked as 1 and 0 respectively in the grid.
Note: m and n will be at most 100.
Example 1:
Input:
[
[0,0,0],
[0,1,0],
[0,0,0]
]
Output: 2
Explanation:
There is one obstacle in the middle of the 3x3 grid above.
There are two ways to reach the bottom-right corner:
1. Right -> Right -> Down -> Down
2. Down -> Down -> Right -> Right
이 문 제 는 이전 문제 입 니 다.  Unique Paths  의 연장 은 경로 에 장애물 을 넣 었 습 니까?아니면 동적 계획 Dynamic Programming 으로 풀 었 습 니까?2 차원 dp 배열 을 사용 합 니 다.크기 는(m+1)x(n+1)입 니 다.여기 dp[i][j]는(i-1,j-1)위치 에 도착 하 는 서로 다른 경로 의 수량 을 표시 합 니 다.그러면 i 와 j 가 업데이트 해 야 할 범 위 는[1,m]와[1,n]입 니 다.상태 전이 방정식 은 이전 문제 와 같 습 니 다.모든 위 치 는 위 와 왼쪽 의 위치 에서 만 이동 할 수 있 기 때문에 위 와 왼쪽 의 dp 값 을 더 해서 현재 의 dp 값 을 업데이트 합 니 다.다음 과 같 습 니 다.
dp[i][j] = dp[i-1][j] + dp[i][j-1]
d p 배열 의 크기 를 초기 화 하 는 것 을 알 수 있 습 니 다. (m+1)x(n+1)는 handle 가장자리 상황 을 위 한 것 으로 i 또는 j 가 0 일 때 1 을 줄 이면 오류 가 발생 할 수 있 습 니 다.어떤 위치 가 장애물 일 때 dp 값 은 0 이 고 이 위 치 를 바로 뛰 어 넘 으 면 됩 니 다.dp 배열 의 특정한 값 을 초기 화하 여 정상적으로 누적 할 수 있 도록 해 야 합 니 다.시작 점 이 장애물 이 아 닐 때 dp 값 은 1,즉 dp[1][1]=1 이 어야 합 니 다.dp[0][1]+dp[1][0]에서 업데이트 되 었 기 때문에 둘 중 하 나 를 1 로 초기 화하 면 됩 니 다.이후 LeetCode 는 이 문제 의 test case 를 업데이트 하여 int 형 dp 배열 을 사용 하면 넘 치 는 오류 가 발생 할 수 있 으 므 로 log 형 배열 을 사용 하여 overflow 를 피 하 는 것 으로 바 꾸 었 습 니 다.코드 는 다음 과 같 습 니 다.
해법 1:

class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        if (obstacleGrid.empty() || obstacleGrid[0].empty() || obstacleGrid[0][0] == 1) return 0;
        int m = obstacleGrid.size(), n = obstacleGrid[0].size();
        vector<vector<long>> dp(m + 1, vector<long>(n + 1, 0));
        dp[0][1] = 1;
        for (int i = 1; i <= m; ++i) {
            for (int j = 1; j <= n; ++j) {
                if (obstacleGrid[i - 1][j - 1] != 0) continue;
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            }
        }
        return dp[m][n];
    }
};
또는 우 리 는 1 차원 dp 배열 을 사용 하여 공간 을 절약 할 수 있 습 니 다.코드 는 다음 과 같 습 니 다.
해법 2:

class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        if (obstacleGrid.empty() || obstacleGrid[0].empty() || obstacleGrid[0][0] == 1) return 0;
        int m = obstacleGrid.size(), n = obstacleGrid[0].size();
        vector<long> dp(n, 0);
        dp[0] = 1;
        for (int i = 0; i < m; ++i) {
            for (int j = 0; j < n; ++j) {
                if (obstacleGrid[i][j] == 1) dp[j] = 0;
                else if (j > 0) dp[j] += dp[j - 1];
            }
        }
        return dp[n - 1];
    }
};
C++구현 LeetCode(63.서로 다른 경로 의 2)에 관 한 이 글 은 여기까지 소개 되 었 습 니 다.더 많은 관련 C++구현 서로 다른 경로 의 2 내용 은 우리 의 이전 글 을 검색 하거나 아래 의 관련 글 을 계속 조회 하 시기 바 랍 니 다.앞으로 많은 응원 부탁드립니다!

좋은 웹페이지 즐겨찾기